; Kontroler sa serijskim CURRENT LOOP izlazom za LED rasvetu
; Voja Antonic, 14.03.2010
; U IDE treba otvoriti Project/Build Options/Project/MPASM Assembler/ i...
; ... cekirati polja Disable case sensitivity i Default Radix Decimal
;                       ____    ____
;                 MCLR |    \__/    | B7  PGD
;       LCD Data 0  A0 |            | B6  PGC
;       LCD Data 1  A1 |            | B5  LCD CS 2
;       LCD Data 2  A2 |            | B4  LCD CS 1
;       LCD Data 3  A3 |            | B3  Data 7 
;         LCD R/-W  A4 |            | B2  Data 6
;           LCD RS  A5 |    2525    | B1  Data 5
;                  Vss |            | B0  Data 4
;         16 MHz   Osc |            | Vdd
;         16 MHz   Osc |            | Vss
;            LCD E  C0 |            | C7  RXD
;        LCD RESET  C1 |            | C6  TXD
; CCPR1L (backlite) C2 |            | C5  Rotary B
;         Rotary A  C3 |____________| C4  Key in (251 out)

#define lcdrw lata,4
#define lcdrs lata,5
#define lcdenable latc,0
#define lcdreset latc,1
#define rotary_a portc,3
#define keyin portc,4
#define rotary_b portc,5
#define lcdcs1 latb,4
#define lcdcs2 latb,5
#define	red latb,6	; !!!
#define	beep latb,7	; !!!

	LIST P=18F2525
	#include <P18F2525.INC>

	config osc = HS		; spoljni keramicki rezonator 16 MHz
	config fcmen = off
	config ieso = off
	config pwrt = on
	config borv = 1
	config wdt = off
	config mclre = off
	config lpt1osc = off
	config pbaden = off
	config stvren = on
	config lvp = off
	config xinst = off
	config debug = off
	config cp0 = off
	config cp1 = off
	config cp2 = off
	config cpb = off
	config cpd = off
	config wrt0 = on
	config wrt1 = on
	config wrt2 = on
	config wrtb = on
	config wrtc = on
	config wrtd = off
	config ebtr0 = off
	config ebtr1 = off
	config ebtr2 = off
	config ebtrb = off
;}
	CBLOCK	0	; RAM definicije

flag			; bit 0: clr=black, set=white
			; bit 1: clr=crno polje za jacinu, set=belo
			; bit 2: clr=normal mode, set=edit mode
			; bit 3: clr=normal ili num edit, set=text edit
			; bit 4: clr=aktivno polje je prazno, ne treba crtati
			; bit 5: set=caps lock set
			; bit 6: TX break char sent
inner
outer
count
tempw
savew			; during INT
savestatus		; during INT
savebsr			; during INT
inner_s
outer_s
count_s
tempw_s
counter
cpwreg
temp1			; za char
temp2			; za char
temp3			; za char
rotor			; za char
xpos			; za kvadrat i liniju
ypos			; za kvadrat i liniju
sirina			; za kvadrat i liniju
visina			; za kvadrat i liniju
beepcount		; brojac aktivnih BEEP ciklusa
rotor_a			; za rotary_a
rotor_b			; za rotary_b
rotarycount		; first counter za rotary
rotor_patience: 2	; za detekciju da je rotary mirovao 1 s
temp4
temp5
;tempfsr0l		; za TX int
;tempfsr0h		; za TX int
autorpt1		; autorepeat counter za key 1
autorpt2		; autorepeat counter za key 2
yrgbsel			; select: 0=y 1=r 2=g 3=b
xoffset			; horiz offset za char, line, box i boxfull
keybyte			; stanje tastera; bit 0 levi taster, bit 7 desni
debo: 8			; debounceri za tastere
adjustw			; stanje potenciometra za globalnu jacinu
mirujew			; koliko dugo glavni pot miruje, za automatski upis u 1 bajt ee
selector		; ptr za biranje slova za txt edit, 0...47
uniform			; za block blink u edit txt modu
editbuf: 15		; polje za editovanje naslova kanala
editptr			; pointer upisa pri text editu 0...15
grupe			; X000XXXX (set=ON) bit 0 prva grupa... bit 3 cetvrta grupa, bit 7 on-off
txbuf: 32		; podaci koji ce se slati sa ser porta
			; +0: break char (dummy value)
			; +1: broj grupe 11111111, 11111110, 11111101, 11111100
			; +2: yellow 0...100
			; +3: red    0...100
			; +4: green  0...100
			; +5: blue   0...100
			; +6: jacina 0...100 (ista je za sve 4 grupe)
			; +7: checksum
			; i tako se ponavlja 4 puta
chs			; checksum
txcount			; tx pointer, 0...47
adjchan			; broj kanala koji se podesava, 0...49 (mada se podesava samo 0...29)
adjparam		; broj parametra za adj, 0...17, 000XGGBB G=grupa B=boja, 16=white
eeram: 34		; 34 bajta iskopirana iz EE (mora da se nalazi na page 0)
			; jacina yellow 0, red 0, green 0, blue 0
			; jacina yellow 1, red 1, green 1, blue 1
			; jacina yellow 2, red 2, green 2, blue 2
			; jacina yellow 3, red 3, green 3, blue 3
			; +16 globalna jacina svetla
			; +17 sa koje se grupe koristi param.boje 33221100, default 11-10-01-00
			; +18...32 naziv kanala koji se podesava, 15 by (...sve se ponavlja 50 puta)
			; +33: dummy 0
			; dalje sledi ono sto ne mora na page 0
clipboard: 18		; copy:		ee --> clipboard, 	paste:	clipboard --> ee (18 by)
undoboard: 34		; nov kanal:	ee --> undoboard, 	undo:	undoboard --> ee (34 by)
redoboard: 34		; undo:		ee --> redoboard,	redo:	redoboard --> ee (34 by)
			; 		undoboard --> ee

	ENDC

	#include <MACROS.INC>

lcdbuffer	equ	200h	; (1024 bajta)
patiencew	equ	.50	; posle koliko vremena ce se nova vrednost pota memorisati u ee

	org	0
	goto	main

;_______________________________________________________
;_______________________________________________________ HI PRIOR INT (T1) oko 4 KHz

	org	8h
;	call	foo,fast
;foo	pop			; bug fix
	goto	hiint
;_______________________________________________________

bittab
	db	80h,40h,20h,10h,08h,04h,02h,01h

;_______________________________________________________
;_______________________________________________________ LO PRIOR INT (RXD)

	org	18h
	goto	loint
;_______________________________________________________

dectab
;{
	db	00h,01h,02h,03h,04h,05h,06h,07h,08h,09h
	db	10h,11h,12h,13h,14h,15h,16h,17h,18h,19h
	db	20h,21h,22h,23h,24h,25h,26h,27h,28h,29h
	db	30h,31h,32h,33h,34h,35h,36h,37h,38h,39h
	db	40h,41h,42h,43h,44h,45h,46h,47h,48h,49h
	db	50h,51h,52h,53h,54h,55h,56h,57h,58h,59h
	db	60h,61h,62h,63h,64h,65h,66h,67h,68h,69h
	db	70h,71h,72h,73h,74h,75h,76h,77h,78h,79h
	db	80h,81h,82h,83h,84h,85h,86h,87h,88h,89h
	db	90h,91h,92h,93h,94h,95h,96h,97h,98h,99h
	db	0a0h,0a0h
	;}
;________________________________ odavde vise ne mora da bude na page 0

poruka1
;{
	db	"Loading...",0
slova1
	db	"!@#$%?&*()<>'",34,"=/"
	db	" ABCDEFGHIJKLMNO"
	db	"PQRSTUVWXYZ",91,92,93,94,95
slova2
	db	"1234567890.,-+;:"
	db	" abcdefghijklmno"
	db	"pqrstuvwxyz",123,124,125,126,127

	#include <led_default.inc>
;}
;***************************                    *******************************
;**************************      M  A  I  N      ******************************
;***************************                    *******************************

main
;{
	movlw	0fh
	movwf	adcon1
	movlw	07h
	movwf	cmcon

				; INTERRUPTS
	movlw	b'11001111'
	movwf	ipr1		; TX, RX interrupts low priority
	bsf	rcon,ipen	; enable int priority
	bsf	intcon,tmr0ie	; enable tmr0 int
;	bsf	pie1,rcie	; enable RX interrupts
	bsf	pie1,txie	; enable TX interrupts

				; TIMER 0
	movlw	b'11000010'	; 8-bit, prescaler 8
	movwf	t0con
				; TIMER 2
	movlw	b'00000111'
	movwf	t2con		; TMR2 prescaler=16, timer 2 on
	movlw	0ffh		; 256t = 1 KHz (osc 16 MHz)
	movwf	pr2
				; PWM 1
	movlw	b'00001100'
	movwf	ccp1con		; pwm1 single mode

				; UART
	movlw	b'00000110'	; TXEN (5) reset, setuje se kasnije jer on setuje i TXIF
	movwf	txsta		; reg TXREG
	movlw	b'10010000'
	movwf	rcsta		; reg RCREG
	movlw	.102
	movwf	spbrg		; 9600 bd

				; PORTS
	clrf	porta		; reset port outputs
	clrf	portb
	clrf	portc
	movlw	b'11000000'
	movwf	trisa		; port I/O definitions
	movlw	b'00000000'
	movwf	trisb
	movlw	b'10111000'
	movwf	trisc

	lfsr	fsr1,0
clram
	clrf	postinc1	; clear RAM 2K
	btfss	fsr1h,3
	goto	clram

	call	inici_lcd
mainfarm2
;	movlw	.80		; default jacina svetla
;	movwf	adjustw
	movlw	b'10001111'	; default sve grupe ukljucene
	movwf	grupe

mainfarm
	clrf	tblptru
	bcf	flag,2
	bcf	flag,3
	
	call	clrbuf
	call	printmem

	bsf	intcon,gieh	; enable hi prior int (TIMER0)
	bsf	intcon,giel	; enable lo prior int (UART)
	bsf	txsta,txen	; ovo setuje i txif
	
	movlw	0fch
	call	readw
	addlw	-.101
	btfsc	status,c
	movlw	.80-.101	; if bad data, default to 80
	addlw	.101
	movwf	adjustw		; globalna jacina

	movlw	0fdh
	call	readw
	movwf	grupe		; stanje on-off grupa

	movlw	0feh
	call	readw
	addlw	-.50
	btfsc	status,c
	movlw	.0-.50		; if bad data, default to channel 0
	addlw	.50
	movwf	adjchan		; broj kanala

	call	rdee
;}

;******************************************************************************
;******************************************************************************
;***************************                    *******************************
;**************************      F  A  R  M      ******************************
;***************************                    *******************************
;******************************************************************************
;******************************************************************************

farm
	call	beepdecif
	movf	adjustw,w
	addlw	.155
	btfss	grupe,7
	movlw	.0
	movwf	ccpr1l		; backlite

	bcf	flag,2
	bcf	flag,3
	bsf	flag,4
	call	printmem
	call	clrbuf
	call	settxbuf
	call	autorpt

	movlw	0
	movwf	xoffset
	bcf	flag,0
	bcf	flag,1
	pos	0,0
	box	0,0,111,11
	vert	15,1,9
	vert	30,1,9
	vert	46,1,9
	vert	62,1,9
	vert	78,1,9
	vert	94,1,9

	pos	4,1
	movlw	30		; strelica nagore
	call	char
	pos	19,1
	movlw	31		; strelica nadole
	call	char

	pos	35,1
	movlw	'A'
	btfsc	grupe,0
	call	grupchar
	call	char
	bcf	flag,0

	pos	51,1
	movlw	'B'
	btfsc	grupe,1
	call	grupchar
	call	char
	bcf	flag,0

	pos	67,1
	movlw	'C'
	btfsc	grupe,2
	call	grupchar
	call	char
	bcf	flag,0

	pos	83,1
	movlw	'D'
	btfsc	grupe,3
	call	grupchar
	call	char
	bcf	flag,0

	pos	99,1
	movlw	17		; pun krug 5 pixela
	btfsc	grupe,7
	call	grupchar
	call	char
	bcf	flag,0
				; iscrtava bele vert linije izmedju crnih blokova
	bsf	flag,0
	movlw	b'00000011'
	andwf	grupe,w
	xorlw	b'00000011'
	bnz	nolv1
	pos	46,1
	movlw	9
	call	linevert
nolv1
	movlw	b'00000110'
	andwf	grupe,w
	xorlw	b'00000110'
	bnz	nolv2
	pos	62,1
	movlw	9
	call	linevert
nolv2
	movlw	b'00001100'
	andwf	grupe,w
	xorlw	b'00001100'
	bnz	nolv3
	pos	78,1
	movlw	9
	call	linevert
nolv3
	movlw	b'10001000'
	andwf	grupe,w
	xorlw	b'10001000'
	bnz	nolv7
	pos	94,1
	movlw	9
	call	linevert
nolv7
	bcf	flag,0

;-------------------
	clrf	xoffset

	decf	adjchan,f
	call	range50
	decf	adjchan,f
	call	range50
	pos	0,13
	call	rdee15		; stampanje 15 by iz eeproma (NASLOV)
	
	incf	adjchan,f
	call	range50
	pos	0,23
	call	rdee15		; stampanje 15 by iz eeproma (NASLOV)
	
	incf	adjchan,f
	call	range50
	incf	adjchan,f
	call	range50
	pos	0,43
	call	rdee15		; stampanje 15 by iz eeproma (NASLOV)
	
	incf	adjchan,f
	call	range50
	pos	0,53
	call	rdee15		; stampanje 15 by iz eeproma (NASLOV)

	boxf	0,33,111,10	; crni box
	bsf	flag,0		; bela slova

	decf	adjchan,f
	call	range50
	decf	adjchan,f
	call	range50
	pos	0,33
	incf	adjchan,w
	call	print100r	; ispisuje broj kanala
	movlw	':'
	call	char
	movf	xpos,w
	addlw	1
	movwf	xpos
	lfsr	fsr1,eeram+18
	call	printxtr16	; ispisuje naziv kanala
	bcf	flag,0		; crna slova

	bcf	flag,1		; crni glider
	lfsr	fsr1,adjustw
	call	wglider
	bcf	flag,1
;-------------------------------- testira da li je globalna jacina dovoljno dugo mirna za upis u ee
	movf	mirujew,f
	bz	vec0mw
	decfsz	mirujew,f
	bra	vec0mw
				; mirujew je upravo stigao do 0
	movlw	0xfc
	call	readw		; cita globalnu jacinu iz ee
	cpfseq	adjustw		; ne upisuje, jer su vec isti
	call	writeadj	; upisuje novi adjustw u ee *****
vec0mw
;--------------------------------
	call	testkbd
	btfsc	status,z
	goto	farm		; nista nije pritisnuto od tastera
				; key just pressed
	decf	wreg,f
	bnz	glnokey1
;----------------------------------- key 1: ch minus
;	movf	adjchan,f
;	bz	ovfto50a
	decf	adjchan,f
	call	range50
	call	rdee
	call	writechan
	goto	farm
;ovfto50a
;	movlw	49
;	movwf	adjchan
;	call	rdee
;	goto	farm
glnokey1	;---------------------------
	decf	wreg,f
	bnz	glnokey2
;----------------------------------- key 2: ch plus
	incf	adjchan,f
	call	range50
;	movlw	.50
;	cpfslt	adjchan
;	clrf	adjchan
	call	rdee
	call	writechan
	goto	farm
glnokey2	;---------------------------
	decf	wreg,f
	bnz	glnokey3
;----------------------------------- key 3: toggle group 1
	btg	grupe,0
	call	writegrup
	goto	farm
glnokey3	;---------------------------
	decf	wreg,f
	bnz	glnokey4
;----------------------------------- key 4: toggle group 2 
	btg	grupe,1
	call	writegrup
	goto	farm
glnokey4	;---------------------------
	decf	wreg,f
	bnz	glnokey5
;----------------------------------- key 5: toggle group 3 
	btg	grupe,2
	call	writegrup
	goto	farm
glnokey5	;---------------------------
	decf	wreg,f
	bnz	glnokey6
;----------------------------------- key 6: toggle group 4
	btg	grupe,3
	call	writegrup
	goto	farm
glnokey6	;---------------------------
	decf	wreg,f
	bnz	glnokey7
;----------------------------------- key 7: toggle global on-off 
	btg	grupe,7
	call	writegrup
	goto	farm
glnokey7	;---------------------------
	decf	wreg,f
	bnz	glnokey8
;----------------------------------- key 8: EDIT MODE
	movlw	.2
	movwf	beepcount
	goto	editmode
glnokey8	;---------------------------
	goto	farm

editmode
;{
	bsf	flag,2		; EDIT MOD
	bcf	flag,3		; NUM EDIT
	clrf	adjparam
rdedfarm
	call	rdee		; cita iz EE ili PGMEM 34 bajta u EERAM, zavisno od ADJCHAN
	call	eeundo
	call	eeredo
	call	eeclip
edfarm:
	call	beepdecif
	movlw	.255
	movwf	ccpr1l		; backlite full
	call	printmem
	call	clrbuf
	call	settxbuf
	call	autorpt
	call	etest		; testiraj da li je polje puno (if yes, flag,4 set)

	pos	0,0
	clrf	xoffset
	incf	adjchan,w
	call	print100r	; ispisuje broj kanala
	movlw	':'
	call	char
	movf	xpos,w
	addlw	1
	movwf	xpos

	lfsr	fsr1,eeram+18
	call	printxtr16	; ispisuje naziv kanala

	call	mreza		; CRTA GLAVNU MREZU U EDIT MODU

	bcf	flag,1		; crni glider
	lfsr	fsr1,eeram+16
	btfsc	adjparam,4
	bra	ostaw

	bsf	flag,1		; beli glider
	movf	adjparam,w
	andlw	0fh
	lfsr	fsr1,eeram
	addwf	fsr1l,f		; tu je parametar za podesavanje (osim glidera)
ostaw
	call	wglider
	bcf	flag,1

	call	testkbd
	bz	edfarm
				; key just pressed
	clrf	beepcount
	bsf	beepcount,1
	decf	wreg,f
	bnz	nokey1

;----------------------------------- key 1

	movf	adjparam,w
	andlw	b'00011100'
	bz	chminus			; overflow na nizi kanal

	decf	adjparam,f
	decf	adjparam,f
	decf	adjparam,f
	decf	adjparam,f
	goto	edfarm
chminus
	call	writee34

;	movf	adjchan,f
;	bz	ovfto50
	decf	adjchan,f
;	goto	rdedfarm
;ovfto50
;	movlw	49
;	movwf	adjchan
	call	range50

	goto	rdedfarm
nokey1	;---------------------------
	decf	wreg,f
	bnz	nokey2

;----------------------------------- key 2

	btfsc	adjparam,4
	bra	chplus			; overflow na visi kanal
	incf	adjparam,f
	incf	adjparam,f
	incf	adjparam,f
	incf	adjparam,f
	goto	edfarm
chplus
	call	writee34
	incf	adjchan,f
	call	range50
;	movlw	.49
;	cpfsgt	adjchan
;	goto	rdedfarm
;	clrf	adjchan
	goto	rdedfarm
nokey2	;---------------------------
	decf	wreg,f
	bnz	nokey3

;----------------------------------- key 3

	btfsc	adjparam,4
	bra	lastline1
	bcf	adjparam,1
	bcf	adjparam,0
	goto	edfarm
lastline1

	btfsc	debo+3,0		; tu je stanje tastera 4
	bra	noundoredo3
	call	eeundo			; *** EE --> UNDO ***
	call	read34			; *** DEFAULT_SETTINGS --> EE ***
	goto	edfarm
noundoredo3				; undo

	movlw	30
	cpfslt	adjchan
	goto	edfarm			; jer taj taster nije aktivan na kanalima >29

	call	eeredo			; *** EE --> REDO ***
	call	undoee			; *** UNDO --> EE ***
	goto	edfarm
nokey3	;---------------------------
	decf	wreg,f
	bnz	nokey4

;----------------------------------- key 4

	btfsc	adjparam,4
	bra	lastline2
	bcf	adjparam,1
	bsf	adjparam,0
	goto	edfarm
lastline2

	btfsc	debo+2,0		; tu je stanje tastera 3
	bra	noundoredo4
	call	eeundo			; *** EE --> UNDO ***
	call	read34			; *** DEFAULT_SETTINGS EEPROM --> EE ***
	goto	edfarm
noundoredo4				; redo

	movlw	30
	cpfslt	adjchan
	goto	edfarm			; jer taj taster nije aktivan na kanalima >29

	call	redoee			; *** REDO --> EE ***
	goto	edfarm
nokey4	;---------------------------
	decf	wreg,f
	bnz	nokey5

;----------------------------------- key 5

	btfsc	adjparam,4
	bra	lastline3
	bsf	adjparam,1
	bcf	adjparam,0
	goto	edfarm
lastline3				; copy
	call	eeclip			; *** EE --> CLIP ***
	goto	edfarm
nokey5	;---------------------------
	decf	wreg,f
	bnz	nokey6

;----------------------------------- key 6

	btfsc	adjparam,4
	bra	lastline4
	bsf	adjparam,1
	bsf	adjparam,0
	goto	edfarm
lastline4				; paste
	movlw	30
	cpfslt	adjchan
	goto	try50			; jer taj taster nije aktivan na kanalima >29

	call	eeundo			; *** EE --> UNDO ***
	call	clipee			; *** CLIP --> EE ***
	goto	edfarm
try50					; see if chan 50 then reload all settings
	movlw	49
	cpfseq	adjchan
	goto	edfarm			; jer nije ch 50
	btfss	adjparam,4
	goto	edfarm			; jer nije u donjem redu
	btfss	flag,2
	goto	edfarm			; jer nije u edit modu
	btfsc	flag,3
	goto	edfarm			; jer je u tekst editoru
	movf	debo+2,w
	iorwf	debo+3,w
	btfss	status,z
	goto	edfarm			; jer nisu pritisnuti tasteri 3 i 4
	call	presetee		; READ EEPROM
	clrf	adjparam
	clrf	adjchan
	goto	mainfarm2
nokey6	;---------------------------
	decf	wreg,f
	bnz	nokey7

;----------------------------------- key 7 TEXT EDIT MODE

	btfsc	adjparam,4
	goto	adjtxt
	btfsc	adjparam,3
	bra	par23
	movlw	b'00000011'
	btfsc	adjparam,2
	movlw	b'00001100'
	bra	incopy
par23
	movlw	b'00110000'
	btfsc	adjparam,2
	movlw	b'11000000'
incopy
	movwf	tempw
	andwf	eeram+17,w
	addlw	b'01010101'
	andwf	tempw,w
	movwf	cpwreg			; tu su nova 2 bita
	comf	tempw,w
	andwf	eeram+17,f
	movf	cpwreg,w
	iorwf	eeram+17,f
	goto	edfarm
nokey7	;---------------------------
	decf	wreg,f
	bnz	nokey8

;----------------------------------- key 8 POVRATAK NA GLAVNI PROGRAM

	movlw	patiencew
	movwf	mirujew			; presetuje patience za upis ajustw u ee
	call	writee34
	movf	eeram+16,w
	movwf	adjustw			; prenosi jacinu svetla
	goto	mainfarm		; povratak u glavni program

nokey8	;---------------------------
	goto	edfarm
;}

;
adjtxt					; text edit
;{
	movlw	.255
	movwf	ccpr1l		; backlite full
	movlw	30
	cpfslt	adjchan
	goto	edfarm		; jer taster 7 nije aktivan na kanalima >29

	bsf	flag,2		; EDIT MOD
	bsf	flag,3		; TEXT EDIT
	bsf	flag,4		; Aktivno polje nije prazno (da ne preskoci interrupt)
	bcf	flag,5		; CAPS LOCK

	movlw	17
	movwf	selector

	lfsr	fsr1,eeram+18
	lfsr	fsr2,editbuf
	movlw	15
	movwf	count
go15
	movf	postinc1,w
	movwf	postinc2	; prepisuje naslov u txt edit buffer
	decfsz	count,f
	bra	go15
	call	clrbuf
				; trazi kraj teksta
	movlw	16
	movwf	editptr
srchend
	decf	editptr,f
	lfsr	fsr1,editbuf-1
	movf	editptr,w
	addwf	fsr1l,f
	movlw	21h
	cpfslt	indf1
	bra	foundend
	movf	editptr,f
	bnz	srchend
foundend			; nasao kraj teksta
	
;---------------------------------------------------------------- TEXT EDIT FARM

txtfarm
	call	beepdecif
	incf	uniform,f
	call	printmem
	call	clrbuf
	call	settxbuf

	movlw	0
	movwf	xoffset
	bcf	flag,0
	bcf	flag,1
	pos	0,0
	box	0,0,126,11
	vert	18,1,9
	vert	36,1,9
	vert	54,1,9
	vert	72,1,9
	vert	90,1,9
	vert	108,1,9

	pos	3,1
	movlw	'S'
	call	char
	movlw	'H'
	call	char
	pos	21,1
	movlw	'O'
	call	char
	movlw	'K'
	call	char
	pos	39,1
	movlw	'C'
	call	char
	movlw	'A'
	call	char
	pos	75,1
	movlw	'B'
	call	char
	movlw	'K'
	call	char
	pos	93,1
	movlw	'S'
	call	char
	movlw	'P'
	call	char
	pos	111,1
	movlw	'W'
	call	char
	movlw	'R'
	call	char


	clrf	xoffset
	pos	2,15
	incf	adjchan,w
	call	print100r	; ispisuje broj kanala
	movlw	':'
	call	char
	movf	xpos,w
	addlw	1
	movwf	xpos

	lfsr	fsr1,editbuf
	call	printxtr16	; ispisuje naziv kanala

	movf	editptr,w
	mullw	6
	movf	prodl,w
	addlw	21
	movwf	xpos
	movlw	27		; block char
	btfss	uniform,3	; blink speed
	call	char

	hor	21,26,91	; linija za underline koja ce biti nazubljenja
	pos	21,25
	movlw	16
	movwf	counter
dots16
	call	drawpixel	; ispisuje tackice na nazubljenoj liniji
	movlw	6
	addwf	xpos
	decfsz	counter,f
	bra	dots16

	movlw	31
	movwf	ypos
	movlw	low slova1	; velika slova (shift)
	btfss	flag,5
	movlw	low slova2	; mala slova
	movwf	tblptrl
	movlw	high slova1	; velika slova (shift)
	btfss	flag,5
	movlw	high slova2	; mala slova
	movwf	tblptrh
	call	print16
	call	print16
	call	print16

	lfsr	fsr1,selector
	call	test_rc		; deli umanjenje/uvecanje rotarycount sa 4 i prenosi na indf1
	movlw	47
	cpfslt	selector
	movwf	selector	; max value 47

	movf	selector,w
	andlw	0fh
	mullw	8
	movf	prodl,w
	movwf	xpos		; xpos boxa
	swapf	selector,w
	andlw	03h
	mullw	11
	movf	prodl,w
	addlw	30
	movwf	ypos		; ypos boxa
	movlw	9
	movwf	sirina
	movlw	117
	cpfslt	xpos
	decf	sirina,f	; da ne bi ispao iz screena kad je u desnoj koloni
	movlw	11
	btfss	flag,5
	movlw	12		; kad su mala slova (no shift), onda je box veci
	movwf	visina
	call	drawbox

	call	testkbd
	btfsc	status,z
	goto	txtfarm
				; key just pressed
	clrf	beepcount
	bsf	beepcount,1
	decf	wreg,f
	bnz	notk1
;------------------------------------ text key 1: CAPS LOCK
	btg	flag,5
	goto	txtfarm
notk1
	decf	wreg,f
	bnz	notk2
;------------------------------------ text key 2: OK
	lfsr	fsr1,editbuf
	lfsr	fsr2,eeram+18
	movlw	15
	movwf	count
go15b
	movf	postinc1,w
	movwf	postinc2	; prepisuje naslov iz txt edit buffera u eeram
	decfsz	count,f
	bra	go15b
	movlw	.2
	movwf	beepcount
	goto	cancel
notk2
	decf	wreg,f
	bnz	notk3
;------------------------------------ text key 3: CANCEL
cancel
	bsf	flag,2
	bcf	flag,3
	goto	edfarm
notk3
	decf	wreg,f
	bnz	notk4
;------------------------------------ text key 4
	goto	txtfarm
notk4
	decf	wreg,f
	bnz	notk5
;------------------------------------ text key 5: BKSP
	movf	editptr,w
	bz	gofarm
	decf	editptr,f
	lfsr	fsr1,editbuf
	movf	editptr,w
	addwf	fsr1l,f		; fsr1 points to place to write to
	movlw	' '
	movwf	indf1
gofarm
	goto	txtfarm
notk5
	decf	wreg,f
	bnz	notk6
;------------------------------------ text key 6: SPACE
	lfsr	fsr1,editbuf
	movf	editptr,w
	addwf	fsr1l,f		; fsr1 points to place to write to
	movlw	.15
	cpfslt	editptr
	goto	txtfarm
	movlw	' '
	movwf	indf1		; upisuje slovo u bafer
	movlw	.14
	cpfsgt	editptr
	incf	editptr,f	; uvecava pointer
	goto	txtfarm
notk6
	decf	wreg,f
	bnz	notk7
;------------------------------------ text key 7: WRITE

	lfsr	fsr1,editbuf
	movf	editptr,w
	addwf	fsr1l,f		; fsr1 points to place to write to
	movlw	.15
	cpfslt	editptr
	goto	txtfarm
	call	findchar
	movwf	indf1		; upisuje slovo u bafer
	movlw	.14
	cpfsgt	editptr
	incf	editptr,f	; uvecava pointer
	goto	txtfarm
notk7
	decf	wreg,f
	bnz	notk8
;------------------------------------ text key 8

	goto	txtfarm		; key 8 nije aktivan u txt edit modu
notk8
	goto	txtfarm

;}
;_____________________________________________________
;_____________________________________________________
;_____________________________________________________ SUBS
;{

delayrate equ	12
rptrate	equ	4

autorpt
	btfss	debo+0,0
	bra	pritisnut1
	movlw	delayrate
	movwf	autorpt1
	bra	gotest2
pritisnut1
	decf	autorpt1,f
	btfss	status,z
	bra	gotest2
	movlw	rptrate
	movwf	autorpt1
	setf	debo+0
gotest2
	btfss	debo+1,0
	bra	pritisnut2
	movlw	delayrate
	movwf	autorpt2
	return
pritisnut2
	decf	autorpt2,f
	btfss	status,z
	return
	movlw	rptrate
	movwf	autorpt2
	setf	debo+1
	return
;_____________

beepdecif
	movf	beepcount,f
	bz	vecoff
	decf	beepcount,f
	bsf	beep
	return
vecoff
	bcf	beep
	return
;_____________

settxbuf			; pripremi TX buffer
	clrf	fsr1h		; fsr1 rd ptr
	lfsr	fsr2,txbuf	; fsr2 wr ptr

	movlw	.101
	movwf	postinc2	; header 101
	movwf	chs
	rlncf	eeram+17,w
	rlncf	wreg,f
	andlw	0ch		; copy param grupe 1
	addlw	eeram		; sa ove grupe salje na tx
	movwf	fsr1l
	movlw	b'11111111'	; adresa za grupu 1
	movwf	postinc2
	addwf	chs,f
	bcf	pie1,txie	; *** disable TX interrupt ***
	movlw	b'01111110'	; grupa 1 (bit 0) i on-off (bit 7)
	call	settx6

	movlw	.101
	movwf	postinc2	; header 101
	movwf	chs
	movf	eeram+17,w
	andlw	0ch		; copy param grupe 2
	addlw	eeram		; sa ove grupe salje na tx
	movwf	fsr1l
	movlw	b'11111110'	; adresa za grupu 2
	movwf	postinc2
	addwf	chs,f
	movlw	b'01111101'	; grupa 2 (bit 1) i on-off (bit 7)
	call	settx6


	movlw	.101
	movwf	postinc2	; header 101
	movwf	chs
	swapf	eeram+17,w
	rlncf	wreg,f
	rlncf	wreg,f
	andlw	0ch		; copy param grupe 3
	addlw	eeram		; sa ove grupe salje na tx
	movwf	fsr1l
	movlw	b'11111101'	; adresa za grupu 3
	movwf	postinc2
	addwf	chs,f
	movlw	b'01111011'	; grupa 3 (bit 2) i on-off (bit 7)
	call	settx6

	movlw	.101
	movwf	postinc2	; header 101
	movwf	chs
	swapf	eeram+17,w
	andlw	0ch		; copy param grupe 4
	addlw	eeram		; sa ove grupe salje na tx
	movwf	fsr1l
	movlw	b'11111100'	; adresa za grupu 4
	movwf	postinc2
	addwf	chs,f
	movlw	b'01110111'	; grupa 4 (bit 3) i on-off (bit 7)
	call	settx6

	bsf	pie1,txie	; *** reenable TX interrupt ***
	return

settx6
	btfsc	flag,2
	bra	ipak_on		; jer u edit modu nema gasenja grupa

	iorwf	grupe,w
	xorlw	b'11111111'
	bnz	nule		; jer nisu setovani bit za tu grupu i on-off bit
ipak_on	
	movf	postinc1,w
	movwf	postinc2	; Y ++
	addwf	chs,f

	movf	postinc1,w
	movwf	postinc2	; R ++
	addwf	chs,f

	movf	postinc1,w
	movwf	postinc2	; G ++
	addwf	chs,f

	movf	postinc1,w
	movwf	postinc2	; B ++
	addwf	chs,f

	movf	adjustw,w	; if normal mode
	btfsc	flag,2
	movf	eeram+16,w	; if edit mode
	movwf	postinc2	; jacina ++

	addwf	chs,w
	movwf	postinc2	; chs ++
	return
nule
	clrf	postinc2	; to je Y
	clrf	postinc2	; to je R
	clrf	postinc2	; to je G
	clrf	postinc2	; to je B
	clrf	postinc2	; to je jacina
	movf	chs,w
	movwf	postinc2	; tu je chs, ne dirati jer je tu adresa
	return
;_____________

grupchar			; zacrnjuje polje za grupu i priprema belo slovo (nema CHAR)
	movwf	tempw		; \
	movff	xpos,temp4	; \\

	movf	xpos,w
	addlw	-4
	movwf	xpos
	movlw	15
	movwf	sirina
	movlw	9
	movwf	visina
	call	boxfull		; zacrnjuje polje

	bsf	flag,0		; da slovo bude belo
	movlw	1
	movwf	ypos
	movf	temp4,w		; //
	movwf	xpos
	movf	tempw,w		; /	char to write (A,B,C,D)
	return
;_____________

findchar			; na izlazu W = ASCII na kome je box
	movlw	low slova1	; velika slova (shift)
	btfss	flag,5
	movlw	low slova2	; mala slova
	movwf	tblptrl
	movlw	high slova1	; velika slova (shift)
	btfss	flag,5
	movlw	high slova2	; mala slova
	movwf	tblptrh
	movf	selector,w
	addwf	tblptrl,f
	btfsc	status,c
	incf	tblptrh,f
	tblrd	*+
	movf	tablat,w
	return

;_____________

range50				; uteruje adjchan u opseg 0...49
	movlw	49
	btfsc	adjchan,7
	movwf	adjchan		; -1 --> 49
	movlw	50
	cpfslt	adjchan
	clrf	adjchan		; >49 --> 0
	return

;_____________

print16				; print 1 red za text edit
	movlw	1
	movwf	xpos
	movlw	16
	movwf	counter
gopr16
	tblrd	*+
	movf	tablat,w
	movff	tblptrl,sirina
	movff	tblptrh,visina
	call	char
	movff	sirina,tblptrl
	movff	visina,tblptrh
	incf	xpos,f
	incf	xpos,f
	decfsz	counter
	bra	gopr16

	movlw	11
	addwf	ypos,f
	return
;_____________

eeredo
	lfsr	fsr1,eeram
	lfsr	fsr2,redoboard		; EERAM --> REDOBOARD
ldir34
	movlw	.34
	movwf	count
ldir
	movf	postinc1,w
	movwf	postinc2
	decfsz	count
	bra	ldir
	return
;_____________

redoee
	lfsr	fsr1,redoboard
	lfsr	fsr2,eeram		; REDOBOARD --> EERAM
	bra	ldir34
;_____________

eeundo
	lfsr	fsr1,eeram
	lfsr	fsr2,undoboard		; EERAM --> UNDOBOARD
	bra	ldir34
;_____________

undoee
	lfsr	fsr1,undoboard
	lfsr	fsr2,eeram		; UNDOBOARD --> EERAM
	bra	ldir34
;_____________


clipee
	lfsr	fsr1,clipboard
	lfsr	fsr2,eeram		; CLIPBOARD --> EERAM
ldir18
	movlw	.18
	movwf	count
	bra	ldir

;_____________

eeclip
	lfsr	fsr1,eeram
	lfsr	fsr2,clipboard		; EERAM --> CLIPBOARD
	bra	ldir18

;____________________________________

mreza
	bcf	flag,0
	movlw	.26
	movwf	xoffset
	box	0,11,75,41
	hor	1,21,73
	hor	1,31,73
	hor	1,41,73
	vert	16,12,39
	vert	32,12,39
	vert	48,12,39
	vert	64,12,39
				; sadrzina 5x4 polja
				; gornji red
	lfsr	fsr1,eeram
	pos	66,12
	clrf	cpwreg
	movf	eeram+17,w
	call	copychar
	bc	noparam1
	pos	2,12
	movf	postinc1,w
	call	print100c
	pos	18,12
	movf	postinc1,w
	call	print100c
	pos	34,12
	movf	postinc1,w
	call	print100c
	pos	50,12
	movf	postinc1,w
	call	print100c
noparam1			; drugi red
	lfsr	fsr1,eeram+4
	pos	66,22
	incf	cpwreg,f
	movf	eeram+17,w
	rrncf	wreg,f
	rrncf	wreg,f
	call	copychar
	bc	noparam2
	pos	2,22
	movf	postinc1,w
	call	print100c
	pos	18,22
	movf	postinc1,w
	call	print100c
	pos	34,22
	movf	postinc1,w
	call	print100c
	pos	50,22
	movf	postinc1,w
	call	print100c
noparam2			; treci red
	lfsr	fsr1,eeram+8
	pos	66,32
	incf	cpwreg,f
	movf	eeram+17,w
	swapf	wreg,f
	call	copychar
	bc	noparam3
	pos	2,32
	movf	postinc1,w
	call	print100c
	pos	18,32
	movf	postinc1,w
	call	print100c
	pos	34,32
	movf	postinc1,w
	call	print100c
	pos	50,32
	movf	postinc1,w
	call	print100c
noparam3			; cetvrti red
	lfsr	fsr1,eeram+12
	pos	66,42
	incf	cpwreg,f
	movf	eeram+17,w
	swapf	wreg,f
	rrncf	wreg,f
	rrncf	wreg,f
	call	copychar
	bc	noparam4
	pos	2,42
	movf	postinc1,w
	call	print100c
	pos	18,42
	movf	postinc1,w
	call	print100c
	pos	34,42
	movf	postinc1,w
	call	print100c
	pos	50,42
	movf	postinc1,w
	call	print100c
noparam4
				; boji u crno param koji se podesava
	movlw	.16
	cpfslt	adjparam
	bra	nocrno
	movf	adjparam,w
	andlw	3
	mullw	.16
	movf	prodl,w
	addlw	1
	movwf	xpos
	movwf	cpwreg
	rrncf	adjparam,w
	rrncf	wreg,f
	andlw	3
	mullw	.10
	movf	prodl,w
	addlw	12
	movwf	ypos
	movlw	.15
	movwf	sirina
	movlw	.9
	movwf	visina
	call	boxfull		; nacrtaj crno polje
	incf	cpwreg,w
	movwf	xpos
	movf	adjparam,w
	addlw	eeram
	movwf	fsr1l
	clrf	fsr1h

	btfss	flag,4		; da li treba upisivati beli broj
	bra	nocrno		; jer ne treba
				; print beo broj
	movf	indf1,w
	bsf	flag,0
	call	print100c
	bcf	flag,0
nocrno
				; ispisuje 1 2 3 4
	pos	-9,12
	movlw	'1'
	call	char
	pos	-9,22
	movlw	'2'
	call	char
	pos	-9,32
	movlw	'3'
	call	char
	pos	-9,42
	movlw	'4'
	call	char

	movlw	.54
	btfsc	adjparam,4
	bra	adp4
	rrncf	adjparam,w
	rrncf	wreg,w
	andlw	3
	mullw	10
	movf	prodl,w
	addlw	12
adp4
	movwf	ypos
	movlw	-.23
	movwf	xpos
	movlw	25		; crtica za trougao nadesno
	call	char
	movlw	29		; trougao nadesno
	call	char
	btfss	adjparam,4
	bra	goyrgb
				; ovde je adjparam>15, treba nacrtati mrezu u 5.redu
	box	0,53,75,11
	vert	16,54,9
	vert	32,54,9
	vert	48,54,9
	vert	64,54,9
				; poruke u 4. redu
	pos	34,54
	movlw	'C'
	call	char
	movlw	'o'
	call	char		; COpy

	movlw	30
	cpfslt	adjchan
	bra	test50		; jer se za kanale >29 ne ispisuje Un Re Pa T

	pos	2,54
	movlw	'U'
	call	char
	movlw	'n'
	call	char		; UNdo
	pos	18,54
	movlw	'R'
	call	char
	movlw	'e'
	call	char		; REdo
	pos	50,54
	movlw	'P'
	call	char
	movlw	'a'
	call	char		; PAste
	pos	66,54
	movlw	'T'
	call	char		; Text
	return

test50				; videti ako je chan 50, ispisati DEF DEF DEF
	movlw	49
	cpfseq	adjchan
	return

	pos	2,54
	movlw	.22		; DE
	call	char
	movlw	.23		; EF
	call	char
	pos	18,54
	movlw	.22		; DE
	call	char
	movlw	.23		; EF
	call	char
	pos	50,54
	movlw	.22		; DE
	call	char
	movlw	.23		; EF
	call	char
	return

goyrgb				; ispisuje Y R G B =
	pos	5,54
	movlw	'Y'
	call	char
	pos	21,54
	movlw	'R'
	call	char
	pos	37,54
	movlw	'G'
	call	char
	pos	53,54
	movlw	'B'
	call	char
	pos	66,54
	movlw	'='
	call	char
	return
;_______________________________

copychar
	andlw	3
	cpfseq	cpwreg
	bra	copyset
	bcf	status,c	; flag no copy
	return
copyset
	addlw	.1
	iorlw	30h
	call	char
	bsf	status,c	; flag copy set
	return
;_______________________________

etest				; testira da li je polje puno ili prazno
	btfsc	adjparam,4
	bra	yesglid

	rrncf	adjparam,w
	rrncf	wreg,f
	andlw	3
	movwf	count
	bnz	no0cpgl
	movf	eeram+17,w
	andlw	b'00000011'
	bz	yesglid
	bra	noglid
no0cpgl
	decf	count,f
	bnz	no1cpgl
	movf	eeram+17,w
	andlw	b'00001100'
	xorlw	b'00000100'
	bz	yesglid
	bra	noglid
no1cpgl
	decf	count,f
	bnz	no2cpgl
	movf	eeram+17,w
	andlw	b'00110000'
	xorlw	b'00100000'
	bz	yesglid
	bra	noglid
no2cpgl
	movf	eeram+17,w
	andlw	b'11000000'
	xorlw	b'11000000'
	bz	yesglid
noglid
	bcf	flag,4		; aktivno polje je prazno, ne treba crtati
	return
yesglid
	bsf	flag,4		; aktivno polje je puno, treba crtati
	return

;_______________________________

wglider				; crta linijski pot, ulazni parametar je na INDF1
	movlw	.113
	movwf	xoffset
wglider0
	box	0,00,15,64
	bsf	flag,0
	boxf	1,1,13,62	; brise polje
	bcf	flag,0

	btfss	flag,4
	bra	noglider
	call	test_rc

	movlw	0		; xpos
	movwf	xpos
	movlw	15		; hor
	movwf	sirina
	movlw	11		; vert
	movwf	visina

	movlw	.52
	movwf	tempw		; \
	incf	indf1,w
	addlw	-101
	bnz	no100
	addlw	2
no100
	addlw	101
	bcf	status,c
	rrcf	wreg
	subwf	tempw,w		; /
	movwf	tempw		; \
	movwf	ypos		; ypos
	btfss	flag,1
	call	boxfull		; box full
	btfsc	flag,1
	call	drawbox		; box empty

	btfss	flag,1
	bsf	flag,0

	movlw	1		; xpos
	movwf	xpos

	movf	tempw,w		; /
	addlw	1
	movwf	ypos		; ypos

	movf	indf1,w
	call	print100c
noglider
	bcf	flag,0
	return
;}
;___________________________________________ kbd

testkbd				; W=0 if no key just hit, else W=1...8
;{
	movlw	0f8h
	andwf	latb,f		; clr bits 2 1 0

	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+7,f
	movf	debo+7,w
	andlw	3
	xorlw	2
	movlw	8
	bz	just

	incf	latb,f
	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+6,f
	movf	debo+6,w
	andlw	3
	xorlw	2
	movlw	7
	bz	just

	incf	latb,f
	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+5,f
	movf	debo+5,w
	andlw	3
	xorlw	2
	movlw	6
	bz	just

	incf	latb,f
	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+4,f
	movf	debo+4,w
	andlw	3
	xorlw	2
	movlw	5
	bz	just

	incf	latb,f
	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+0,f
	movf	debo+0,w
	andlw	3
	xorlw	2
	movlw	1
	bz	just

	incf	latb,f
	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+1,f
	movf	debo+1,w
	andlw	3
	xorlw	2
	movlw	2
	bz	just

	incf	latb,f
	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+2,f
	movf	debo+2,w
	andlw	3
	xorlw	2
	movlw	3
	bz	just

	incf	latb,f
	bsf	status,c
	btfss	keyin
	bcf	status,c
	rlcf	debo+3,f
	movf	debo+3,w
	andlw	3
	xorlw	2
	movlw	4
	bz	just
	movlw	0
just
	addlw	0		; set/clr Z flag
	return			; W=0 if no key just hit, else W=1...8
;}
;___________________________________________ arith

print100r			; stampa w kao 2 cifre (right just)
;{
	addlw	dectab
	movwf	tblptrl
	clrf	tblptrh
	tblrd	*
	movlw	0a0h
	cpfslt	tablat
	bra	sto		; if tablat >=100
	movff	tablat,tempw
	swapf	tablat,w
	andlw	0fh
	bz	ripple2
	iorlw	30h
	call	char		; desetice
	bra	nocent
ripple2
	incf	xpos,f
	incf	xpos,f
	incf	xpos,f
	bra	ripple
print100c			; stampa w kao 2 cifre (center)
	addlw	dectab
	movwf	tblptrl
	clrf	tblptrh
	tblrd	*
	movlw	0a0h
	cpfslt	tablat
	bra	sto		; if tablat >=100
	movff	tablat,tempw
	swapf	tablat,w
	andlw	0fh
	bz	ripple
	iorlw	30h
	call	char		; desetice
	bra	nocent
ripple
	incf	xpos,f
	incf	xpos,f
	incf	xpos,f
nocent
	movf	tempw,w
	andlw	0fh
	iorlw	30h
	call	char		; jedinice
	return
sto
	movlw	.20		; prva polovina 100
	call	char
	movlw	.21		; druga polovina 100
	call	char
	return

print1c				; stampa w kao 1 cifru
	andlw	0fh
	iorlw	30h
	goto	char
;}
;___________________________________________ rotarycount

test_rc			; deli umanjenje/uvecanje rotarycount sa 4 i prenosi na indf1
;{
	bcf	intcon,tmr0ie	; disable tmr0 int
again
	btfsc	rotarycount,7
	bra	nalevo

	movlw	3
	cpfsgt	rotarycount	; rc-3 skip if rc>3
	bra	noplus

	movlw	.99
	cpfsgt	indf1		; indf1-99 skip if indf1>99
	call	incindf		; ++++++++++

	movf	rotarycount,w
	addlw	-4
	movwf	rotarycount
	bra	again
noplus
	bsf	intcon,tmr0ie	; enable tmr0 int
	return
nalevo
	movlw	0fdh
	cpfslt	rotarycount	; rc-0fdh skip if rc<-0fdh
	bra	nominus

	movf	indf1,f
	btfss	status,z
	call	decindf		; ---------

	movf	rotarycount,w
	addlw	4
	movwf	rotarycount
	bra	again
nominus
	bsf	intcon,tmr0ie	; enable tmr0 int
	return

decindf:			; ---------
	decf	indf1,f
	bra	xindf
incindf:			; ++++++++++
	incf	indf1,f
xindf
	movlw	patiencew
	movwf	mirujew			; if rotary modified, preset patience for ee auto wr
	return
;}
;___________________________________________ LCD

	#include <LCD128064.INC>	; printmem: stampa buffer 1024...2047
					; inicilcd: inicijalizuje lcd
					; (trashes fsr2, uses 14 ram pos)
;___________________________________________

printxtp				; print text (TBLPTR) iz pgm mem, terminator 0
;{
	tblrd	*+
	movf	tablat,w
	bz	gotovtxtp
	movff	tblptrl,sirina
	movff	tblptrh,visina
	call	char
	movff	sirina,tblptrl
	movff	visina,tblptrh
	bra	printxtp
gotovtxtp
	return
;___________________________________________

printxtr				; print text (FSR1) iz rama, terminator 0
	movf	postinc1,w
	bz	gotovtxtr
	call	char
	bra	printxtr
gotovtxtr
	return
printxtr16				; print text (FSR1) iz rama, tacno 16 slova
	movlw	.16
	movwf	counter
goprint16
	movf	postinc1,w
	call	char
	decfsz	counter,f
	bra	goprint16
	return
;}
	
;___________________________________________

char				; input: w (ascii), xpos, ypos
				; trashes fsr2, tempw_s, rotor, temp1, temp2, temp3, inner_s, outer_s
				; advances xpos
;{
	movwf	tempw_s
	call	calcxy		; izlaz: byte=fsr2, bit=W (bit set)
	movwf	temp3       ; \\\

	movf	tempw_s,w
	andlw	7fh		; jer je ascii samo do 127
	mullw	.10		; toliko bajtova je jedno slovo

	movlw	low charg1
	addwf	prodl,w
	movwf	tblptrl
	movlw	high charg1
	addwfc	prodh,w
	movwf	tblptrh		; tblptr = ASCII * 10 + charg1

	movlw	.10		; pixel row counter
	movwf	outer_s
gochar1				; ---\
	movff	temp3,tempw_s ; ///
	movff	fsr2h,temp1 ; \
	movff	fsr2l,temp2 ; \\

	tblrd	*+			; u TABLAT je row

	movlw	.6
	movwf	inner_s
	movlw	20h
	movwf	rotor
gochar2				; --\
	btfsc	flag,0
	bra	noblack1	; if no black pixel

	movf	tablat,w
	andwf	rotor,w
	bz	nopix1		; do not set pixel

	movf	tempw_s,w
	iorwf	indf2,f		; set pixel !!!
nopix1
	rrncf	rotor,f
	rrncf	tempw_s,f
	btfsc	tempw_s,7
	movf	postinc2,f	; samo da bi uvecao fsr2 if bit wrap
	bra	bioblack1
noblack1
	movf	tablat,w
	andwf	rotor,w
	bz	nopix2		; do not clear pixel

	movf	tempw_s,w
	andwf	indf2,f		; clear pixel !!!
nopix2
	rrncf	rotor,f
	rrncf	tempw_s,f
	btfss	tempw_s,7
	movf	postinc2,f	; samo da bi uvecao fsr2 if bit wrap
bioblack1
	decfsz	inner_s
	bra	gochar2		; --/

	movf	temp2,w     ; //
	addlw	.16
	movwf	fsr2l
	movff	temp1,fsr2h ; /
	btfsc	status,c
	incf	fsr2h,f

	decfsz	outer_s,f
	bra	gochar1		; ---/

	movf	xpos,w
	addlw	.6		; advance xpos
	movwf	xpos
	return
;}
;___________________________________________

;{
drawpixel			; input: xpos, ypos
	call	calcxy
	btfss	flag,0
	iorwf	indf2,f		; set pixel !!!
	btfsc	flag,0
	andwf	indf2,f		; if white draw
	return
;________________________________

boxfull				; input: xpos, ypos, sirina, visina
	movf	visina,w
	call	linevert
	incf	xpos,f
	decfsz	sirina,f
	bra	boxfull
	return
;________________________________

drawbox				; input: xpos, ypos, sirina, visina
	movf	sirina,w
	call	linehor		; gornja linija
	movf	visina,w
	call	linevert	; leva linija

	movff	ypos,tempw_s

	decf	visina,w
	addwf	ypos,f
	movf	sirina,w
	call	linehor		; donja linija

	movff	tempw_s,ypos

	decf	sirina,w
	addwf	xpos,f
	movf	visina,w
	call	linevert	; desna linija
	return
;________________________________

linehor				; input: xpos, ypos, w
	movwf	count_s		; tolika ce biti linija
	call	calcxy
gohor
	btfsc	flag,0
	bra	noblack		; if no black pixel
	iorwf	indf2,f		; set pixel !!!
	rrncf	wreg,f
	btfsc	wreg,7
	movf	postinc2,f	; samo da bi uvecao fsr2 if bit wrap
	bra	bioblack
noblack
	andwf	indf2,f		; if white draw
	rrncf	wreg,f
	btfss	wreg,7
	movf	postinc2,f	; samo da bi uvecao fsr2 if bit wrap
bioblack
	decfsz	count_s
	bra	gohor
	return
;________________________________

linevert			; input: xpos, ypos, w
	movwf	count_s		; tolika ce biti linija
linevert9
	call	calcxy
govert
	btfss	flag,0
	iorwf	indf2,f		; set pixel !!!
	btfsc	flag,0
	andwf	indf2,f		; if white draw

	movwf	tempw_s
	movf	fsr2l,w
	addlw	.16
	movwf	fsr2l		; fsr2 = fsr2 + 16 (next Y pos)
	btfsc	status,c
	incf	fsr2h		; if page boundary
	movf	tempw_s,w

	decfsz	count_s
	bra	govert
	return
;________________________________

calcxy				; ulaz: xpos, ypos
				; izlaz: byte=fsr2, bit=W (bit set)
	movf	ypos,w
	andlw	3fh		; limit 63
	mullw	16
	movf	prodl,w
	addlw	low lcdbuffer
	movwf	fsr2l
	movf	prodh,w
	addlw	high lcdbuffer
	movwf	fsr2h		; fsr2=Y*16+lcdbuffer (limit lcdbuffer+1008)

	movf	xpos,w
	addwf	xoffset,w
	rrncf	wreg,f
	rrncf	wreg,f
	rrncf	wreg,f
	andlw	0fh		; w=X/8 (limit 15)

	addwf	fsr2l,f
	btfsc	status,c
	incf	fsr2h		; fsr2=Y*16+x/8+lcdbuffer 
				; (limit lcdbuffer+1023) u tom bajtu je pix

	movf	xpos,w
	addwf	xoffset,w
	andlw	7
	addlw	bittab
	movwf	tblptrl
	clrf	tblptrh
	tblrd	*
	movf	tablat,w	; samo jedan bit je setovan
	btfsc	flag,0
	comf	wreg,f		; if white draw
	return
;________________________________

clrbuf
	lfsr	fsr2,lcdbuffer
	clrf	count
goclr
	clrf	postinc2
	clrf	postinc2
	clrf	postinc2
	clrf	postinc2
	decfsz	count,f
	bra	goclr
	return
;}
;_____________________________________________
;_____________________________________________ EEPROM

presetee				; presetuj 1K EEPROMA iz tabele u pgm mem
;{
	bcf	flag,0
	call	clrbuf
	clrf	xoffset
	pos	37,26
	movlw	low poruka1
	movwf	tblptrl
	movlw	high poruka1
	movwf	tblptrh
	call	printxtp		; "Loading..."
	call	printmem
	
	movlw	low default_settings
	movwf	tblptrl
	movlw	high default_settings
	movwf	tblptrh

	clrf	eeadr
	clrf	eeadrh
	clrf	count
	call	wree1
	call	wree1
	call	wree1
	call	wree1

	movlw	.2
	movwf	beepcount
	return
;________________________________

read34			; cita 34BY iz tabele (34*ADJCHAN+DEFAULT_SETTINGS) i upisuje u EERAM
	movlw	low default_settings
	movwf	tblptrl
	movlw	high default_settings
	movwf	tblptrh

	movf	adjchan,w
	mullw	.34

	movf	prodl,w
	addwf	tblptrl,f
	movf	prodh,w
	addwfc	tblptrh,f

	lfsr	fsr2,eeram
	movlw	.34
	movwf	count
gopres34	
	tblrd	*+
	movff	tablat,postinc2
	decfsz	count
	bra	gopres34
	return
;________________________________

writee34			; upisuje 34 bajta sa EERAM u EEPROM na ADJCHAN*34
	movlw	.30
	cpfslt	adjchan
	return			; ne upisuje ako je ADJCHAN > 29
	
	movf	adjchan,w
	mullw	.34
	movff	prodl,eeadr
	movff	prodh,eeadrh
	lfsr	fsr2,eeram
	movlw	.34
	movwf	count
	call	wree2
	return
;________________________________

wree1				; upisuje COUNT bajtova iz TBLPTR u EEADRH:EEADR
gowree1
	bcf	intcon,gieh	; DI ---------
	bcf	intcon,giel	; DI ---------
	tblrd	*+
	movf	tablat,w
	call	wrwee	
	decfsz	count,f
	bnz	gowree1;?????????????????????????????????????????????????????????????
	bsf	intcon,giel	; EI ---------
	bsf	intcon,gieh	; EI ---------
	return

wree2				; upisuje COUNT bajtova iz FSR2 u EEADRH:EEADR
gowree2
	bcf	intcon,gieh	; DI ---------
	bcf	intcon,giel	; DI ---------
	movf	postinc2,w
	call	wrwee	
	decfsz	count,f
	bnz	gowree2;?????????????????????????????????????????????????????????????
	bsf	intcon,giel	; EI ---------
	bsf	intcon,gieh	; EI ---------
	return

writechan			; upisuje [adjchan] u pos 1022

	bcf	intcon,gieh	; DI ---------
	bcf	intcon,giel	; DI ---------
	movlw	low .1022
	movwf	eeadr
	movlw	.3
	movwf	eeadrh
	movf	adjchan,w
	bra	skrwr
writegrup			; upisuje [grupe] u pos 1021

	bcf	intcon,gieh	; DI ---------
	bcf	intcon,giel	; DI ---------
	movlw	low .1021
	movwf	eeadr
	movlw	.3
	movwf	eeadrh
	movf	grupe,w
	bra	skrwr
writeadj			; upisuje [adjustw] u pos 1020 (globalna jacina)

	bcf	intcon,gieh	; DI ---------
	bcf	intcon,giel	; DI ---------
	movlw	low .1020
	movwf	eeadr
	movlw	.3
	movwf	eeadrh
	movf	adjustw,w
skrwr
	call	wrwee
	bsf	intcon,giel	; EI ---------
	bsf	intcon,gieh	; EI ---------
	return

wrwee				; upisuje W (samo 1 bajt) u EEADRH:EEADR, inc EEADRH:EEADR
	bcf	pir2,eeif
	clrf	eecon1
	movwf	eedata
	bsf	eecon1,wren
	nop
	nop
	movlw	55h
	movwf	eecon2
	movlw	0aah
	movwf	eecon2
	bsf	eecon1,wr
waitwr
	btfss	pir2,eeif
	bra	waitwr

	bcf	eecon1,wren
	bcf	pir2,eeif
	incf	eeadr,f
	btfsc	status,z
	incf	eeadrh,f
	return
;________________________________

rdee				; READ defaut values (kanal ADJCHAN) to ram (34 bytes)
				; if ADJCHAN <30, read from EE
				; if ADJCHAN >29, read from program memory (fixed settings)
	movlw	.30
	cpfslt	adjchan
	bra	fixeds

	movf	adjchan,w
	mullw	.34
	movff	prodl,eeadr
	movff	prodh,eeadrh
	lfsr	fsr2,eeram

	movlw	.34
	movwf	counter

rdeexx				;   ***   read COUNTER bytes from EE to (fsr2)   ***
	clrf	eecon1
	bsf	eecon1,rd
	movff	eedata,postinc2
	incf	eeadr,f
	btfsc	status,z
	incf	eeadrh,f
	decfsz	counter,f
	bra	rdeexx
	return

readw				; cita pos (lo byte in W, hi byte 3) na izlazu u w
	movwf	eeadr
	movlw	.3
	movwf	eeadrh
	clrf	eecon1
	bsf	eecon1,rd
	movf	eedata,w
	return

rdee15			; ulaz: adjchan 0-49, stampa 15 by iz eeproma (pgm mem) na LCD
	movlw	.15
	movwf	counter
	lfsr	fsr2,editbuf

	movlw	.30
	cpfslt	adjchan
	bra	fixeds2

	movf	adjchan,w
	mullw	34
	movlw	18		; toliko je do naslova
	addwf	prodl,w
	movwf	eeadr
	movlw	0
	addwfc	prodh,w
	movwf	eeadrh
	call	rdeexx		; prepis 15 by iz eeproma u editbuf
gobk
	incf	adjchan,w
	call	print100r	; ispisuje broj kanala
	movlw	':'
	call	char
	incf	xpos,f
	lfsr	fsr1,editbuf
	call	printxtr16	; ispisuje naziv kanala
	return


fixeds2
	movf	adjchan,w
	addlw	-.30
	mullw	.34
	movlw	low (fixed_settings+18)
	addwf	prodl,w
	movwf	tblptrl
	movlw	high (fixed_settings+18)
	addwfc	prodh,w
	movwf	tblptrh
	call	fixsxx
	bra	gobk

fixeds
	movf	adjchan,w
	addlw	-.30
	mullw	.34
	movlw	low fixed_settings
	addwf	prodl,w
	movwf	tblptrl
	movlw	high fixed_settings
	addwfc	prodh,w
	movwf	tblptrh
	lfsr	fsr2,eeram

	movlw	.34
	movwf	counter
fixsxx				;   ***   read COUNTER bytes from TBLPTR to (fsr2)   ***
	tblrd	*+
	movff	tablat,postinc2
	decfsz	counter,f
	bra	fixsxx
	return

	;}
;________________________________

	#include <CHARG.INC>
;______________________________________________________________
;______________________________________________________________ Hi pripor int

hiint				; u HI INTu opsluzuje rotary switch
;{
	btfss	flag,4
	bra	intexit		; jer je aktivno polje prazno

	bcf	status,c
	btfsc	rotary_a
	bsf	status,c
	rlcf	rotor_a

	movf	rotor_a,w
	andlw	3
	bz	nochan_a
	xorlw	3
	bz	nochan_a
	xorwf	rotor_b,w
	btfss	wreg,0
	incf	rotarycount,f
	btfsc	wreg,0
	decf	rotarycount,f
nochan_a
	bcf	status,c
	btfsc	rotary_b
	bsf	status,c
	rlcf	rotor_b

	movf	rotor_b,w
	andlw	3
	bz	nochan_b
	xorlw	3
	bz	nochan_b
	xorwf	rotor_a,w
	btfsc	wreg,0
	incf	rotarycount,f
	btfss	wreg,0
	decf	rotarycount,f
	movlw	16			; za oko 1 s patience pri 4 KHz
	movwf	rotor_patience+1
	bra	intexit
nochan_b
	movf	rotor_patience+1,w
	bz	preset2
	decf	rotor_patience,f
	bnz	intexit
	decf	rotor_patience+1,f
	bnz	intexit
preset2
	bcf	rotarycount,0
	bsf	rotarycount,1
intexit
	bcf	intcon,tmr0if
	retfie	fast
;}
;______________________________________________________________
;______________________________________________________________ Lo pripor int

loint				; u LO INTu opsluzuje TX, trashes fsr0
	movwf	savew
	movff	status,savestatus
	movff	bsr,savebsr

	movf	txcount,w	; txcount
	addlw	txbuf
	movwf	fsr0l
	clrf	fsr0h
	movff	indf0,txreg	; transmit
skrbreak
	incf	txcount,f	; txcount ++
	movlw	1fh
	andwf	txcount,f

	movff	savebsr,bsr
	movf	savew,w 
	movff	savestatus,status
	retfie

	; TX PROTOKOL (9600,8,n,1):

	; 00 00 char
	; 01 b'11111100' (grupa 1 adresa)
	; 02 grupa 1 Y
	; 03 grupa 1 R
	; 04 grupa 1 G
	; 05 grupa 1 B
	; 06 jacina
	; 07 chs za grupu 1

	; 08 00 char
	; 09 b'11111101' (grupa 2 adresa)
	; 10 grupa 2 Y
	; 11 grupa 2 R
	; 12 grupa 2 G
	; 13 grupa 2 B
	; 14 jacina
	; 15 chs za grupu 2

	; 16 00 char
	; 17 b'11111110' (grupa 3 adresa)
	; 18 grupa 3 Y
	; 19 grupa 3 R
	; 20 grupa 3 G
	; 21 grupa 3 B
	; 22 jacina
	; 23 chs za grupu 3

	; 24 00 char
	; 25 b'11111111' (grupa 4 adresa)
	; 26 grupa 4 Y
	; 27 grupa 4 R
	; 38 grupa 4 G
	; 29 grupa 4 B
	; 30 jacina
	; 31 chs za grupu 4

;_________________________________________
	
	end
